#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
unsigned long addr, size;
char* useraddr;
long kcode()
{
	memcpy(useraddr, addr, size);
	return 0xaabbccdd;
}

main(int argc, char **argv)
{
	char *tmp;
	int fd, n=0, copied=0;
	unsigned int ret;
	if (argc != 4) {
		fprintf(stderr, "usage: %s: xenaddr size filename\n", argv[0]);
		exit(1);
	}
	addr = strtoul(argv[1], &tmp, 0);
	if (*tmp) {
		fprintf(stderr, "%s: err parsing %s\n", argv[0], argv[1]);
		exit(1);
	}
	size = strtoul(argv[2], &tmp, 0);
	if (*tmp) {
		fprintf(stderr, "%s: err parsing %s\n", argv[0], argv[2]);
		exit(1);
	}
	useraddr=malloc(size);
	fd=open(argv[3], O_WRONLY|O_CREAT, 0600);
	if (fd<0) {
		perror("open");
		exit(1);
	}
	memset(useraddr, 0, size);
	ret = run0(kcode);
	if (ret != 0xaabbccdd) {
		printf("ret=0x%x", ret);
		return 1;
	} 
	do {
		n = write(fd, useraddr+copied, size-copied);
		if (n<=0) {
			perror("write");
			exit(1);
		}
		copied+=n;
	} while (copied<size);		
	return 0;

}
